public class Subclass {
 public String name; 
 public int catNum;
 public int lowBound;
 public int highBound;
 public HashMap<String, Integer> weekday;
 public int[] rank;
 public boolean vis;
 
 Subclass(String s, int catn, int lower) {
   this.name = s;
   this.catNum = catn;
   this.lowBound = lower;
   this.highBound = lower + 9;
   this.weekday = new HashMap<String, Integer>(6);
   this.rank = new int[7];
   this.vis = false;
 }
 
 public Subclass(Subclass dna) {
  this.name = dna.name;
  this.catNum = dna.catNum;
   this.lowBound = dna.lowBound;
   this.highBound = dna.highBound;
   this.weekday = new HashMap<String, Integer>(6);
   this.rank = new int[7];
   this.vis = false;
   
   this.weekday.putAll(dna.weekday);
   for(int i=0;i<7;i++) this.rank[i] = dna.rank[i];
 
 
   //print("IM Carxt");
   //printWeek();
 }
 
 
 public void addWeekday(String wd, int v, int l) {
   Integer vv = new Integer(v);
   weekday.put(wd, vv);
   addWeekdayAgain(l, v);
 }
 
 private void addWeekdayAgain(int loc, int val) {
   rank[loc] = val;
 }
 
 public void sortWeek() {
   this.rank = sort(this.rank); 
 }
 
 public Integer getWeekdayVal(String wd) {
   return weekday.get(wd); 
 }
 
 
 
 
 
 public void printSelf() {
   println("NAME: " + this.name + " " + this.lowBound + "-" + this.highBound + " #" + this.catNum + " VIS? " + this.vis);
 }
 
 public void printWeek() {
   /*for(String key : weekday.keySet() ) {
     println( key + " AND " + weekday.get(key) );
   }   */
   println(weekday);
   for(int i=0; i<7;i++) print(rank[i] + " ");
   println();
 }
 
}

public class Catclass {
 String name; 
 public int catNum;
 public int lowBound;
 public int highBound;
 public boolean isFocus;
 
 Catclass(String s, int n) {
   this.name = s;
   this.catNum = n;
   this.lowBound = n*100;
   this.highBound = n*100 + 99;
   this.isFocus = false;
 }
 
}

